package WebFlow.event;
import org.omg.CORBA.*;

public class PropertyChangeEventImpl extends _PropertyChangeEventImplBase{
   
    /**
     * @param source  The bean that fired the event.
     * @param propertyName  The programmatic name of the property
     *		that was changed.
     * @param oldValue  The old value of the property.
     * @param newValue  The new value of the property.
     */
    public PropertyChangeEventImpl(org.omg.CORBA.Object source, 
			       String propertyName,
			       org.omg.CORBA.Any oldValue, 
			       org.omg.CORBA.Any newValue) 
   {
        source_ = source;
	this.propertyName = propertyName;
	this.newValue = newValue;
	this.oldValue = oldValue;
    }

    public PropertyChangeEventImpl(org.omg.CORBA.Object source, 
			       String propertyName,
			       String oldValue, 
			       String newValue) 
   {
        org.omg.CORBA.ORB orb_ = org.omg.CORBA.ORB.init();
        Any any_oldValue = orb_.create_any();
	any_oldValue.insert_string(oldValue);
	Any any_newValue = orb_.create_any();
	any_newValue.insert_string(newValue);

        source_ = source;
	this.propertyName = propertyName;
	this.newValue = any_newValue;
	this.oldValue = any_oldValue;
    }

   public PropertyChangeEventImpl(org.omg.CORBA.Object source, 
			       String propertyName,
			       org.omg.CORBA.Object oldValue, 
			       org.omg.CORBA.Object newValue) 
   {
        org.omg.CORBA.ORB orb_ = org.omg.CORBA.ORB.init();
        Any any_oldValue = orb_.create_any();
	any_oldValue.insert_Object(oldValue);
	Any any_newValue = orb_.create_any();
	any_newValue.insert_Object(newValue);

        source_ = source;
	this.propertyName = propertyName;
	this.newValue = any_newValue;
	this.oldValue = any_oldValue;
    }

  
    /**
     * @return  The programmatic name of the property that was changed.
     *		May be null if multiple properties have changed.
     */
    public String getPropertyName() {
	return propertyName;
    }
    
    public  void setPropertyName(String propertyName) {
	this.propertyName = propertyName;
    }
 
    /**
     * @return  The new value for the property, expressed as an Object.
     *		May be null if multiple properties have changed.
     */
    public org.omg.CORBA.Any getNewValue() {
	return newValue;
    }

    /**
     * @return  The old value for the property, expressed as an Object.
     *		May be null if multiple properties have changed.
     */
    public org.omg.CORBA.Any getOldValue() {
	return oldValue;
    }   

    public void  setNewValue(org.omg.CORBA.Any any_newValue) {
       this.oldValue = null;
       this.newValue = any_newValue;
       propertyName = "NONE";
  }

  public void setOldValue(org.omg.CORBA.Any any_oldValue) {
    this.newValue = null;
    this.oldValue = any_oldValue;
    propertyName = "NONE";
  } 

    public org.omg.CORBA.Object getSource(){
	return source_;
    }

    public void  setSource(org.omg.CORBA.Object source_){
	this.source_= source_;
    }

  public void parseSimpleValue(String value){}
  public void parseStructValue(String[] values, int[] dims){}
  public void parseSequenceValue(String[] values, int[] dims){}
  public String parseXmlValue(){return null;}

    private org.omg.CORBA.Object source_;
  
    private String propertyName;
    private org.omg.CORBA.Any newValue;
    private org.omg.CORBA.Any oldValue;
    private org.omg.CORBA.Object propagationId;
}

