package WebFlow.util;

import WebFlow.event.*;
import WebFlow.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.util.Hashtable;
import java.util.Vector;
import org.omg.CORBA.*;
import java.net.*;
import WebFlow.xml.*;
import org.w3c.dom.*;


public class install {

   public static Document  root;
   public static org.omg.CORBA.Object server;
   public static Hashtable moduleTable;
   public static org.omg.CORBA.ORB orb;
  public static org.omg.CORBA.Object []ms = new org.omg.CORBA.Object[30];
  public static int cnt=0;

   public static void  main (String []args)
   {
     if (args.length < 2){
       System.out.println("install xmlFileName masterurl");
       return;
     }
     orb = ORB.init(args, new java.util.Properties());

     String xmlfileName = args[0];
     String masterURL = args[1];
     String masterRef = waitForMaster(masterURL);
     org.omg.CORBA.Object server = orb.string_to_object(masterRef);
     install installer = new install(server, xmlfileName);
     installer.makeInstall();
     waitForInput();
   }

   public static String  waitForMaster(String masterURL)
   {
     String ref=null;
     org.omg.CORBA.Object obj=null;
     boolean flag=true;
     while(flag){
       ref = getIORFromURL(masterURL);
       obj = orb.string_to_object(ref);
       boolean non_exist = true;
       try{
	 non_exist = obj._non_existent();
       }catch(org.omg.CORBA.COMM_FAILURE ex){}
       catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
       
       if (!non_exist)
	 flag = false;
       try{
	 Thread.sleep(500);
       }catch(InterruptedException ex){
       }
     }
     return ref;
  }

   public install (org.omg.CORBA.Object server, String xmlFileName)
   {

     this.server = server;
     moduleTable  = new Hashtable();

     Document document=null;
     try{
        DOMParser parser = new DOMParser();
        root = parser.parse(xmlFileName);
     }catch (Exception e) {
        e.printStackTrace(System.err);
        return;
     }

     //store the IOR of WebFlow server in DOM tree
     NodeList elements = root.getElementsByTagName("WebFlowContext");
     Element outerContext = (Element)elements.item(0);

     //ORB:transform to IOR
     String contextIOR = orb.object_to_string(server);
     //String contextIOR ="";
     ms[cnt++] =  server;
     outerContext.setAttribute("ior", contextIOR);
    
   }
   
   public static  void makeInstall()
   {
     makeInstall_ex(root);
     makeConnection();
   }

   public static void makeInstall_ex(Node root)
   {
       NodeList list = root.getChildNodes();
       for(int k=0;k<list.getLength();k++){
	 Node node = list.item(k);
         int type = node.getNodeType();
	 if (type != Node.ELEMENT_NODE)
	   continue;
	 Element next = (Element)node;
	 String tag = next.getTagName();
	 if (tag.equals("WebFlowContext")){
	   installContext(next);
	   makeInstall_ex(next);
	 }
	 else if (tag.equals("ModuleInstance"))
	    installModule(next);
	 else
	   makeInstall_ex(node);

       }
   }
  
   public static Element getNode(Element parent, String nodeTag)
   {
     Node next=null;
     for(next=parent.getFirstChild();next!=null;next=next.getNextSibling()){
       Node node = next;
       int type = node.getNodeType();
       if (type != Node.ELEMENT_NODE)
	 continue;
       Element elem = (Element)node;
       if (elem.getTagName().equals(nodeTag))
	 break;
     }
     return (Element)next;
   }

   public static void installContext(Element contextNode)
   {
     Element parent = (Element)contextNode.getParentNode();
     //assume that outermost context, webflow server is ready
     //If context is Webflow server, return
     if (parent.getTagName().equals("distributed_application"))
       return;

     //obtain parent WebFlow context
     String parentIOR = parent.getAttribute("ior");
     //ORB:transform from IOR to real CORBA Object
     org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
     WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
     

     //create now new context
     String ID = contextNode.getAttribute("componentID");
     System.out.println("Install context:"+ID);
     //ORB:transform to IOR
     org.omg.CORBA.Object new_context=null;
     try{
       new_context = parentContext.addNewContext(ID);
     }catch(PropertyVetoException e){
       System.out.println("Install context:"+e);System.exit(0);}
     catch(WebFlow.NullPointerException e){
       System.out.println("Install context:"+e);System.exit(0);}
     String next_contextIOR = orb.object_to_string(new_context);
     //String next_contextIOR="";

     //set my IOR
     contextNode.setAttribute("ior", next_contextIOR);

     //add it into object list
     System.out.println(cnt+":"+ID);
     ms[cnt++] = new_context;
   }

   public static void installModule(Element moduleNode)
   {
     Element parent = (Element)moduleNode.getParentNode();

     //obtain parent WebFlow context
     String parentIOR = parent.getAttribute("ior");
     //ORB:transform from IOR to CORBA Object
     org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
     WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
     
     //create now new Module
     //get componentRef Node
     Element compRefNode = getNode(moduleNode, "componentRef");
     String compRef = compRefNode.getFirstChild().getNodeValue();
     Element modeIDNode = getNode(moduleNode, "moduleID");
     String moduleID = modeIDNode.getFirstChild().getNodeValue();
     System.out.println("installModule:compRef:"+compRef+" modeID:"+moduleID);

      //ORB:transform to IOR
     org.omg.CORBA.Object new_module=null;
     new_module = parentContext.addNewModule(compRef);
     String next_moduleIOR = orb.object_to_string(new_module);
     //org.omg.CORBA.Object new_module = null;
     //String next_moduleIOR ="";

     //add it into object list
     System.out.println(cnt+":"+moduleID);
     ms[cnt++] = new_module;
     
     //set my IOR
     moduleNode.setAttribute("ior", next_moduleIOR);
     //add new instantiated module into table for connecting events
     //ORB:put the module reference to table
     moduleTable.put(moduleID, new_module); 
     //moduleTable.put(modeID, "");

     //now set attributes if any
     BeanContextChild bcc = BeanContextChildHelper.narrow(new_module);
     bcc.restoreXMLProperties();
   }

  public static void makeConnection()
   {
     NodeList connections = root.getElementsByTagName("connect");
     for(int k=0;k<connections.getLength();k++)
       {
	 org.omg.CORBA.Object sourceObj,targetObj;
	 
	 Element connect = (Element)connections.item(k);
	 String connectMode =  connect.getAttribute("typeOfConnection");
	 String eventRef =  connect.getAttribute("eventRef");
	 System.out.println("makeConnection:connectMode:"+connectMode+
			    " eventRef:"+eventRef);

	 Element parent = (Element)connect.getParentNode().getParentNode();
	 //obtain parent WebFlow context
	 String parentIOR = parent.getAttribute("ior");
	 //System.out.println("makeConnection:parentIor:"+parentIOR);
	 //ORB:transform from IOR to CORBA Object
	 org.omg.CORBA.Object obj = orb.string_to_object(parentIOR);
	 WebFlowContext parentContext = WebFlowContextHelper.narrow(obj);
	
	 //find source
	 Element source = getNode(connect, "sourceObject");
	 Element moduleRefNode = getNode(source, "moduleRef");
	 String  sourceModuleRef = moduleRefNode.getFirstChild().getNodeValue();
	 //ORB:get source reference from table
	 sourceObj = (org.omg.CORBA.Object)moduleTable.get(sourceModuleRef);
	 

	 System.out.println("sourceModuleRef :"+sourceModuleRef);
 
         //find target
	 Element target = getNode(connect, "targetObject");
	 moduleRefNode = getNode(target, "moduleRef");
	 String targetModuleRef = moduleRefNode.getFirstChild().getNodeValue();
	 //ORB:get target reference from table
	 targetObj = (org.omg.CORBA.Object)moduleTable.get(targetModuleRef);
	 System.out.println("targetModuleRef :"+targetModuleRef);

	 //find target method
	 Node targetMethodNode;
	 targetMethodNode = getNode(target, "targetMethod");
	 String targetMethod = targetMethodNode.getFirstChild().getNodeValue();
	 System.out.println("targetMethod :"+targetMethod);

	 //check second parameter of XpushX and XPullX methods?????????
	 //ORB:not the time to make connection
	 if (connectMode.equals("push"))
	   parentContext.attachPushEvent(sourceObj,eventRef,
					 targetObj,targetMethod);
	 else if (connectMode.equals("pull"))
	   parentContext.attachPullEvent(sourceObj,eventRef,
					 targetObj);
       }
   }
 
   
  public static String  getIORFromURL(String url) 
  {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
	try {
	  URL u = new URL(url);
	  // now turn the URL into a DataInputStream
	  try {
	    DataInputStream theHTML = new DataInputStream(u.openStream());
	    try {
	      while ((thisLine = theHTML.readLine()) != null) {
		masterServerIOR += thisLine;
	      } // while loop ends here
	    }  // end try
	    catch (Exception e) {
	      System.out.println("install:getIORfromURL:"+e);
	    }
	  } // end try
	  catch (Exception e) {
	    System.out.println("install:getIORfromURL:"+e);
	  }

	} // end try
	catch (MalformedURLException e) {
	  System.out.println("install:getIORfromURL:"+url + 
			     " is not a parseable URL");
	  System.out.println("install:getIORfromURL:"+e);
	}
	return masterServerIOR;
  }
  

public static void waitForInput()
  {
    String input;
    boolean flag=true;
    try{
    do
      {
	System.out.print(">>>> ");
	DataInputStream dataIn = new DataInputStream(System.in);
	BufferedReader in =
	  new BufferedReader(new InputStreamReader(dataIn));
	input = in.readLine();
	
	if(input.indexOf("d") == 0){
	  //int c = Integet.parseInt(input.substring(1,1));
	  int index_1 = input.indexOf("-");
	  int index_2 = input.lastIndexOf("-");
	  int ci = Integer.parseInt(input.substring(1,index_1));
	  int mi = Integer.parseInt(input.substring(index_1+1,index_2));
	  int mj = Integer.parseInt(input.substring(index_2+1));
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);

	  System.out.println("Client: Detaching property p1-k1");
	  wfc.detachPushEvent(ms[mi],"timeElapsed",ms[mj],"getTime");
	}
	if(input.indexOf("rc") == 0){
	  int index = input.indexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  int mi = Integer.parseInt(input.substring(index+1));
	  System.out.println("Client: Remove context:"+mi+" from context:"+ci);
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
	  wfc.removeContext(ms[mi]);
	}
	
	if(input.indexOf("rm") == 0){
	  int index = input.indexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  int mi = Integer.parseInt(input.substring(index+1));
	  System.out.println("Client: Remove child:"+mi+" from context:"+ci);
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
	  wfc.removeModule(ms[mi]);
	}
	if(input.indexOf("cm") == 0){
	  int index = input.indexOf("-");
	  int lindex = input.lastIndexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  int mi = Integer.parseInt(input.substring(index+1,
						    lindex));
	  int mj = Integer.parseInt(input.substring(lindex+1));
	  System.out.println("Client: Remove child:"+mi+" from context:"+ci);
	  WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
	  wfc.copyModuleBinding(ms[mi], ms[mj]);
	}
	if(input.indexOf("ci") == 0){
	  int index = input.indexOf("-");
	  int ci = Integer.parseInt(input.substring(2,index));
	  String name = input.substring(index+1);
	  System.out.println("Client: Change Impl of :"+ci+" with:"+name);
	  BeanContextChild bcc = BeanContextChildHelper.narrow(ms[ci]);
	  bcc.changeImpl(name);
	}
	if(input.indexOf("ri") == 0){
	  int ci = Integer.parseInt(input.substring(2));
	  System.out.println("Client: Remoev itself of :"+ci);
	  BeanContextChild bcc = BeanContextChildHelper.narrow(ms[ci]);
	  bcc.removeMyself();
	}
	if(input.indexOf("li") == 0){
	  int ci = Integer.parseInt(input.substring(2));
	  System.out.println("Client: List :"+ci);
	  listContents(ms[ci]);
	}
	//xmlb : save as binary... xmla: save as ascii xml file
	if(input.indexOf("xml") == 0){
	  char  cc = input.charAt(3);
	  String saveCase="";
	  if (cc == 'b')
	    saveCase = "binary";
	  else if (cc == 'a')
	    saveCase = "ascii";

	  int ci = Integer.parseInt(input.substring(4));
	  System.out.println("Client: xml :"+ci);
	  WebFlowContext wfc=WebFlowContextHelper.narrow(ms[ci]);
	  String xmlFragment = wfc.saveStateInXml(saveCase);
	  System.out.println(wfc.getObjectID()+
			     " got this XML Document:"+xmlFragment);
	}
      }while(flag);
    }catch(IOException e){}
}

static public void listContents(org.omg.CORBA.Object context)
  {
    WebFlowContext wfc = WebFlowContextHelper.narrow(context);
    System.out.println("This Context has the following childs:"+
			wfc.getObjectID());
    org.omg.CORBA.Object []list = wfc.toArray();
     System.out.println("This Context has :"+list.length+" children..");
    for(int k=0;k<list.length;k++){
      BeanContextChild bcc = BeanContextChildHelper.narrow(list[k]);
      String id = bcc.getObjectID();
      System.out.println("Next child:"+id);
    }


  }
 
}


